<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Users;
use app\models\Subdistrict;

/**
 * SubdistrictSearch represents the model behind the search form about `app\models\Users`.
 */
class SubdistrictSearch extends Subdistrict
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['subdistrict_id', 'create_user', 'update_user'], 'integer'],
            [['district','state','subdistrict_name','subdistrict_village', 'status', 'create_time', 'update_time','record_date'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {    
		$sloc=Yii::$app->user->identity->signedin_loc;
		$suser=Yii::$app->user->identity->users_name;
		
		$Usermodel = Users::find()->where(['users_name' => $suser])->one();			   
		$UserRole= $Usermodel->user_role;	
		
		$stateid=Yii::$app->user->identity->state_id;

		if($UserRole == 1) 
		  $query = Subdistrict::find();
		elseif($UserRole == 2) 
		  $query = Subdistrict::find()->where(["state_id"=>$stateid]);
		elseif($UserRole == 3) 
		  $query = Subdistrict::find()->where(["district"=>$sloc]);   
		  

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
			'sort'=>[
                'defaultOrder'=>['state'=> SORT_ASC,'district'=> SORT_ASC],
            ],
        ]);
        if(empty($params))
            $params = Yii::$app->request->post();
        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'subdistrict_id' => $this->subdistrict_id,
			'state' => $this->state,
            'status' => $this->status,			
            'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,           
        ]);

        $query->andFilterWhere(['like', 'subdistrict_name', $this->subdistrict_name])
		      ->andFilterWhere(['like', 'subdistrict_village', $this->subdistrict_village])
		      ->andFilterWhere(['like', 'district', $this->district]);          
           
        return $dataProvider;
    }
}
